Numbered Final Question Options by Alice Grove begins here.

[Warning: This is a work in progress and has been only minimally tested! This is version 0.4, I guess.]

Table of Final Option Numbers
printed number (text)	matchable number (topic)	printed option (text)
"1"	"1"	
"2"	"2"	
"3"	"3"
"4"	"4"
"5"	"5"
"6"	"6"
"7"	"7"
"8"	"8"
"9"	"9"
"10"	"10"


The chosen table of final options is a table name that varies.

The chosen table of final options is usually the Table of Final Question Options.

List-final-options-vertically is a truth state that varies. List-final-options-vertically is usually false.

This is the print the final question with numbered options rule:
	let named options count be 0;
	repeat through the chosen table of final options:
		if the only if victorious entry is false or the story has ended finally:
			if (there is a final response rule entry) or (the final response activity entry is not empty):
				if there is a final question wording entry, increase named options count by 1;
	if the named options count is less than 1, abide by the immediately quit rule;
	if list-final-options-vertically is true:
		say "What would you like to do?[paragraph break]" (A);
	otherwise:
		say "Would you like to " (B);
	repeat through the Table of Final Option Numbers:
		if there is a printed option entry:
			blank out the printed option entry;		
	repeat through the chosen table of final options:
		if the only if victorious entry is false or the story has ended finally:
			if there is a final response rule entry or the final response activity entry [activity] is not empty:
				if there is a final question wording entry:
					let corresponding option be the final question wording entry;
					let current option number be a text;
					repeat through the Table of Final Option Numbers:
						if (there is no printed option entry) and (there is a printed number entry): 
							now the printed option entry is the corresponding option;
							now the current option number is the printed number entry;
							break;
					if list-final-options-vertically is true:
						say "[fixed letter spacing][current option number][if number of characters in current option number is 1] [end if] [roman type][final question wording entry][line break]" (C);
						decrease named options count by 1;
						if the named options count is 0:
							say line break;
					otherwise:
						say "[current option number]) [final question wording entry]" (D);
						decrease named options count by 1;
						if the named options count is 1:
							if the serial comma option is active, say "," (E);
							say " or " (F);
						otherwise if the named options count is 0:
							say "?[line break]" (G);
						otherwise:
							say ", " (H);

The print the final question with numbered options rule is listed instead of the print the final question rule in before handling the final question.

 
This is the respond to final question with numbered options rule:
	[Check for a matching number]
	let corresponding option be "";
	repeat through the Table of Final Option Numbers:
		if there is a matchable number entry:
			if (the player's command matches the matchable number entry) and (there is a printed option entry):
				now the corresponding option is the printed option entry;
				break;
	[If the player has entered a number that matches one of the options, choose that one]			
	if corresponding option is not "":
		repeat through the chosen table of final options:
			if (the only if victorious entry is false) or (the story has ended finally):
				if (there is a final response rule entry) or (the final response activity entry [activity] is not empty):
					if there is a final question wording entry:
						if the final question wording entry is the corresponding option:
							if there is a final response rule entry, abide by final response rule entry;
							otherwise carry out the final response activity entry activity;
							rule succeeds;		
	[Check for keywords]
	repeat through the chosen table of final options:
		if (the only if victorious entry is false) or (the story has ended finally):
			if (there is a final response rule entry) or (the final response activity entry is not empty):
				if the player's command matches the topic entry:
					if there is a final response rule entry, abide by final response rule entry;
					otherwise carry out the final response activity entry activity;
					rule succeeds;
	say "Please enter a number from the options above." (A).
	
The respond to final question with numbered options rule is listed instead of the standard respond to final question rule in the for handling the final question rulebook.

To convert the/-- final options, to sentence case or to lower case:
	repeat through the chosen table of final options:
		if there is a final question wording entry:
			let new wording be a text;
			if to sentence case:
				now new wording is the final question wording entry in sentence case;
			otherwise if to lower case:
				now new wording is the final question wording entry in lower case;
			now the final question wording entry is new wording.
			
[To convert final options to lowercase:
	repeat through the chosen table of final options:
		if there is a final question wording entry:
			let new wording be the final question wording entry in lower case;
			now the final question wording entry is new wording.]
		

Numbered Final Question Options ends here.

---- DOCUMENTATION ----

Often, Inform games end with the question "Would you like to RESTART, RESTORE a saved game, QUIT or UNDO the last command?" The question uses capital letters to show which word the player is expected to type.

This extension automatically adds a number in front of each option. The numbers are intended to be more screen reader friendly than using capital letters to distinguish keywords. The player can respond by entering either the number or the keyword.

The extension allows printing the options in a sentence or in a vertical list, and allows automatically converting the options to sentence case text or lower case text.

Numbers will be added for to up to ten options. 


Section: Basic use

If we just want to add the numbers and don't want to set any special options, we can simply include the extension, and do nothing else.

	*: Include Numbered Final Question Options by Alice Grove.


Section: Using a different table

By default, Inform stores the final options in a table called Table of Final Question Options. However, if you create a new table of options to use instead--for example, a Table of Fancy Final Options--you can add the line

	The chosen table of final options is the Table of Fancy Final Options.

and your Table of Fancy Final Options will be used instead. If you make a new table, please make sure the column names and types are identical to the ones in the Table of Final Question Options. See "§11.6 Ending The Story" in the documentation for details about that table. You do not need to number the entries in your table--the extension will number the options automatically when they are printed.


Section: Sentence case text or lower case text

If we like Inform's built-in options, but we don't want the keywords in all capital letters, we convert the options to sentence case (where only the first letter in the phrase will be a capital letter)
	
	*: When play begins:
		convert the final options, to sentence case;
		
or to all lower case letters:

	*: When play begins:
		convert the final options, to lower case;
		
The comma is needed because "to sentence case" and "to lower case" are phrase options.	


Section: Printing the options in a vertical list

If we would rather the options be printed in a vertical list instead of in a sentence, we can add the line

	*: List-final-options-vertically is true.
	
and the resulting text will look like this:
	
	What would you like to do?

	1  RESTART
	2  RESTORE a saved game
	3  QUIT
	4  UNDO the last command

	
Section: Limitations
	
If for some reason we want to include more than ten options in the final question, we'll need to continue the Table of Final Question Numbers (begun in this extension) to add more numbers.

If a player tries to enter both the number and the keyword together, or tries to include the ")" symbol following the number, that will not be understood. If the player's answer is not understood, the response printed is "Please enter a number from the options above."


Example: * Jump In - A minimal example.

	*: Include Numbered Final Question Options by Alice Grove.
	
	When play begins:
		convert final options, to sentence case.

	Diving Board is a room. The description is "Don't wait! All you need to do is jump!"
	
	Rule for amusing a victorious player: say "Have you tried waiting?" 
	
	Carry out waiting:
		end the story saying "YOU HAVE LOST".

	Carry out jumping:
		end the story finally saying "YOU HAVE WON".
		
	Test me with "jump".
